package hu.elte.inf.akxml.zh2017;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import javax.xml.XMLConstants;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.dom.DOMSource;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 *
 * @author menyhart
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws ParserConfigurationException, FileNotFoundException, SAXException, IOException, XPathExpressionException {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        dbf.setIgnoringComments(true);
        dbf.setNamespaceAware(true);
        dbf.setIgnoringElementContentWhitespace(true);

        //DTD validalas 2. és 3.
        //dbf.setValidating(true);
        DocumentBuilder db = dbf.newDocumentBuilder();
        InputSource is = new InputSource(new FileInputStream(new File("src/hu/elte/inf/akxml/zh2017/zh.xml")));
        Document d = db.parse(is);

        SchemaFactory factory = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
        Schema schema = factory.newSchema(new File("src/hu/elte/inf/akxml/zh2017/zh.xsd"));
        dbf.setSchema(schema);
        Validator validator = schema.newValidator();
        DOMSource xmlPart = new DOMSource(d.getDocumentElement());
        validator.validate(xmlPart);

        XPath xpath=XPathFactory.newInstance().newXPath();
        //Javítsd az XPath kifejezest ugy, Urbancsovics Géza második szolgáltatásának paramétereit írja ki
        String xpath_str="//*";
        XPathExpression xexp=xpath.compile(xpath_str);
        System.out.println("XPATH : "+xexp.evaluate(d.getDocumentElement()));
        
        //TODO A projektben írd meg egy adatmódosító eljárást, ami bejárja a DOM fát, és a szolgáltatások neveit NAGYBETŰsíti.
        
        
    }


}
